use bitboard::Bitboard;
use std::sync::mpsc::{Receiver, Sender};
use movegen::Move;

pub enum EngineMsg {
    SetBoard,
    SetPiece(Bitboard),
    Search(i32),
    Ping,
    Stop,
    GetState,
    GetInfo,
}


pub enum EngineState {
    Idle,
    Searching
}


pub enum InterfaceMsg {
    BestMove(Move),
    State(EngineState)
}


pub fn run_engine(r: Receiver<EngineMsg>, s: Sender<InterfaceMsg>) {
    for msg in r {
        println!("engine received message");
    }
}

