use bitboard::Bitboard;
use search::Game;

pub type Square = u8;
pub type Side = bool;

pub const WHITE: Side = false;
pub const BLACK: Side = true;

pub type PieceType = u8;

pub const PAWN:     PieceType = 0;
pub const KNIGHT:   PieceType = 1;
pub const BISHOP:   PieceType = 2;
pub const ROOK:     PieceType = 3;
pub const QUEEN:    PieceType = 4;
pub const KING:     PieceType = 5;


pub struct SimpleMove {
    from: Square,
    to: Square,
}

pub enum Move {
    Default     { mov: SimpleMove, capture: PieceType },
    Castling    { side: Side, left: bool },
    EnPassant   { side: Side, column: u8},
    Promotion   { side: Side, column: u8, promote_to: PieceType },
}


pub struct BitboardIterator { pub board: Bitboard }

impl Iterator for BitboardIterator {
    type Item = Bitboard;

    fn next(&mut self) -> Option<Bitboard> {
        if self.board != 0 {
            let lsb = self.board & (0_u64.wrapping_sub(self.board));
            self.board &= !lsb;
            //Some(lsb.trailing_zeros())
            Some(lsb)
        }
            else {
                None
            }
    }
}


fn generate_pawn_moves(game: &Game, side: Side) 
{
    let pawns = game.pawns(side);
}



#[cfg(test)]
mod tests {
    use search::Game;
    use movegen::*;
    #[test]
    fn pawn_pushes() {
        let game: Game = Game::default();
        let pawn_moves = generate_pawn_moves(&game, WHITE);
        assert_eq!(pawn_moves, ());
    }
}




